//+------------------------------------------------------------------+
//|                                                           AC.mq4 |
//|                      Copyright  2010, Dmitry Zhebrak aka Necron |
//|                                                  www.mqlcoder.ru |
//+------------------------------------------------------------------+
//|                        |
//|.           |
//| ( Necron ).     |
//|   ,    .  |
//|     .                    |
//|      ,    |
//|  .                              |
//|  ,                  |
//|       email:           |
//|mqlcoder@yandex.ru                                                |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, D.Zhebrak aka Necron"
#property link      "www.mqlcoder.ru"
#property link      "mailto: mqlcoder@yandex.ru"

#define   version   "1.0.0.1"

//----    Profitunity_MT4
#include <b-Profitunity_MT4.mqh>
//----    
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  Black
#property  indicator_color2  Red
#property  indicator_color3  Lime
#property  indicator_color4  Blue
#property  indicator_color5  Violet
#property  indicator_color6  Orange

//----   
//extern int     BarsToProcess=200;      //     (-1 )
extern bool    alert=true;             // true  
extern int     width=1;                //  
//----    
double      ExtBuffer0[],
            ExtBuffer1[],
            ExtBuffer2[],
            ExtBuffer3[],
            ExtBuffer4[],
            ExtBuffer5[];
//----               
datetime    bar;
bool        s1=false,
            s2=false,
            s3=false;
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
int init()
  {
//----     
   bar=0;
   s1=false;
   s2=false;
   s3=false;
//----        
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
   SetIndexBuffer(5,ExtBuffer5);   
//----    
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_ARROW,0,width);
   SetIndexStyle(4,DRAW_ARROW,0,width);
   SetIndexStyle(5,DRAW_ARROW,0,width);
//----    
   SetIndexArrow(3,119);
   SetIndexArrow(4,119);
   SetIndexArrow(5,119);
//----      
   IndicatorDigits(Digits+2);  
//----         
   IndicatorShortName("i-AC");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,"i-AC: 2 bars");
   SetIndexLabel(4,"i-AC: 3 bars");
   SetIndexLabel(5,"i-AC: Crossing zero");
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }  
//+------------------------------------------------------------------+
//| Accelerator/Decelerator Oscillator                               |
//+------------------------------------------------------------------+
int start()
  {
//---- ,        
   int    limit,limit2;
   int    counted_bars=IndicatorCounted();
   double prev,current;

//----    
   if(counted_bars<0) return(-1);
//----     
   if(iBars(Symbol(),Period())<35) 
    {
     Print("Not enough bars for calculation!");
     return(-1); 
    }    
//----      
   limit = Bars - counted_bars-1;
   if(Bars - counted_bars > 2) limit = Bars-35;
   if(limit>BarsToProcess && BarsToProcess>0) limit=BarsToProcess;
   limit2=limit;
   
//----   
   for(int i=limit; i>=0; i--)
      ExtBuffer0[i]=iAC(NULL,0,i);
//----  
   for(i=limit; i>=0; i--)
     {
      if(ExtBuffer0[i]>ExtBuffer0[i+1])
        {
         ExtBuffer2[i]=ExtBuffer0[i];
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=ExtBuffer0[i];
         ExtBuffer2[i]=0.0;
        }
     }
//----        
   for(i=limit2;i>=0;i--)
     {
      if(bull_double_bar_above(i)|| bear_double_bar_below(i))
       {
         ExtBuffer3[i]=ExtBuffer0[i];
         if(i==1)s1=true;
       }
      if(bull_triple_bar_below(i)|| bear_triple_bar_above(i)) 
       {
        ExtBuffer4[i]=ExtBuffer0[i];
        if(i==1)s2=true;
       }
      if(bull_cross_and_double_bar(i)|| bear_cross_and_double_bar(i))
       {
        ExtBuffer5[i]=ExtBuffer0[i];
        if(i==1)s3=true;
       }
     }
//----  ()      
   if(alert)
    { 
     if(bar<Time[0]) 
      {
       if(s1)
        {
         Alert("i-AC: Signal 2 bars up/down of zero at ",Symbol(),"_",Period(),"");
        }
       if(s2)
        {
         Alert("i-AC: Signal 3 bars up/down of zero at ",Symbol(),"_",Period(),"");
        }
       if(s3)
        {
         Alert("i-AC: Signal 2 bars and crossing zero at ",Symbol(),"_",Period(),"");
        } 
       bar=Time[0];  
       s1=false;
       s2=false;
       s3=false;
      }
    }  
   return(0);
  }
//+------------------------------------------------------------------+


